#include <avr/io.h>
#include <util/delay.h>
#include <string.h>
#include <time.h>
#include <stdlib.h>
#include "lcd.h"
#define F_CPU 16000000
#define GUESSED 52366

char alphabet[26] = {
	'a', 'b', 'c', 'd', 'e', 'f', 
	'g', 'h', 'i', 'j', 'k', 'l', 
	'm', 'n', 'o', 'p', 'q', 'r', 
	's', 't', 'u', 'v', 'x', 'y', 'z',
};

char *cuvinte[6] = {
	"hangman", "lcd", "carapace", 
	"cinci", "examen", "sesiune"
};

void drawSkel(char *cuvant, int size, int *guessed, int vieti, 
		char *guessedLetters, int *won) 
{
	int i;
	char l = (char)(((int) '0') + vieti);
	char *tmp = "Gsd:";
	char alreadyGuessed[25];

	strcpy(alreadyGuessed, tmp);
	strcat(alreadyGuessed, guessedLetters);

	for (i = 0; i < size; i++) {
		if (guessed[i] == 0)
			break;
	}

	if (i == size) {
		*won = 1;
		LCD_print("You won!");
		LCD_printAt(40, "Congratz");	
	}
	else {
		if (vieti == 0) {
			LCD_print("You lost");
		}
		else 
		{
			for (i = 0; i < size; i++) {
				if (!guessed[i])
					LCD_print("*");
				else
					LCD_putChar(cuvant[i]);
			}
			LCD_printAt(13, "V:");
			LCD_putCharAt(15, l);	

			LCD_printAt(40, alreadyGuessed);
		}
	}

}


int isInWord(char c, char *cuvant, int *guessed, int size, 
		char *guessedLetters, int *lettersGsd, int pos, int line) 
{
	int i, found = 0;

	for (i = 0; i < size; i++) {
		if (cuvant[i] == c && guessed[i] == 1)
			return GUESSED;
		if (cuvant[i] == c && guessed[i] == 0) {
			guessed[i] = 1;
			found++;
		}
	}
	
	for (i = 0; i < *lettersGsd * 2 + 1; i++) {
		if (c == guessedLetters[i])
			return -1;
	}


	guessedLetters[*lettersGsd * 2] = alphabet[pos + line];
	guessedLetters[*lettersGsd * 2 + 1] = ',';
	guessedLetters[*lettersGsd * 2 + 2] = '\0';
	(*lettersGsd)++;
	return found;
}

void selection(int pos, int button, char *cuvant, int *guessed, 
	       int size, char *selectedLetters, int *lettersGsd, 
	       int *vieti, int *won)	
{
	char *selectedMsgOrig = "You selected: ";
	char selectedMsg[20]; 	


	strcpy(selectedMsg, selectedMsgOrig);
	selectedMsg[14] = alphabet[pos + button];
	selectedMsg[15] = '\0';
	if (won == 0) {
		LCD_printAt(40, selectedMsg);
	}
	if(isInWord(alphabet[pos + button], cuvant, guessed, size,
		selectedLetters, lettersGsd, pos, button) == 0)
				(*vieti)--;
	LCD_printAt(40, selectedMsg);
}

int main()
{

	srand(time(NULL));
	LCD_init();
	LCD_print("Hi!");
	_delay_ms(4000);

	//high nibble for output(columns) low for input(rows)
	DDRA = 0xF0;
	//enable internal pullups for PB0-PB3
	PORTA = 0x0F;

	int random = rand() % 6, vieti = 6, pos = -1, lettersGuessed = 0; 

	int size = strlen(cuvinte[random]);
	int *guessed = calloc(size, sizeof(int));
	int won = 0;
	char *cuvant = cuvinte[random];
	char *selectedLetters = malloc(sizeof(char) * 24 * 2 + 1);

	while (1) //loop key check forever
	{

		LCD_writeInstr(LCD_INSTR_clearDisplay);
		drawSkel(cuvinte[random], size, guessed, vieti,
			       	selectedLetters, &won);
		_delay_ms(5);

		// A patra coloana
		PORTA = 0b01111111;

		// tasta *
		if (!bit_is_set(PINA, 3)) {
			while (!bit_is_set(PINA, 3));
		}


		// tasta C
		if (!bit_is_set(PINA, 2)) {

			while (!bit_is_set(PINA, 2));
			if (pos != -1) {
				selection(pos, 2, cuvant, guessed, size, 
						selectedLetters, &lettersGuessed, 
						&vieti, &won);
			}
			_delay_ms(1000);
		}


		// tasta B
		if (!bit_is_set(PINA, 1)) {

			while (!bit_is_set(PINA, 1));
			if (pos != -1) {
				selection(pos, 1, cuvant, guessed, size, 
						selectedLetters, &lettersGuessed, 
						&vieti, &won);
			}
			_delay_ms(1000);
		}


		// tasta A
		if (!bit_is_set(PINA, 0)) {

			while (!bit_is_set(PINA, 0));
			if (pos != -1) {
				selection(pos, 0, cuvant, guessed, size, 
						selectedLetters, &lettersGuessed, 
						&vieti, &won);
			}
			_delay_ms(1000);
		}

		//a treia coloana			  
		PORTA = 0b10111111;

		// tasta D
		if (!bit_is_set(PINA, 3)) {

			while (!bit_is_set(PINA, 3));
		}

		// tasta 9
		if (!bit_is_set(PINA, 2)) {

			while (!bit_is_set(PINA, 2));
			pos = 24;
		}

		//tasta 6
		if (!bit_is_set(PINA, 1)) {

			while (!bit_is_set(PINA, 1));
			pos = 15;
		}

		//tasta 3
		if (!bit_is_set(PINA, 0)) {

			while (!bit_is_set(PINA, 0));
			pos = 6;
		}
		//a 2a coloana

		PORTA = 0b11011111;

		// tasta #
		if (!bit_is_set(PINA, 3)) {

			while (!bit_is_set(PINA, 3));
		}

		//tasta 8
		if (!bit_is_set(PINA, 2)) {

			while (!bit_is_set(PINA, 2));
			pos = 21;
		}

		// tasta 5
		if (!bit_is_set(PINA, 1)) {

			while (!bit_is_set(PINA, 1));
			pos = 12;
		}

		// tasta 2
		if (!bit_is_set(PINA, 0)) {

			while (!bit_is_set(PINA, 0));
			pos = 3;
		}

		//prima coloana 					  
		PORTA = 0b11101111;

		//tasta 0
		if (!bit_is_set(PINA, 3)) {

			while (!bit_is_set(PINA, 3));
		}

		// tasta 7
		if (!bit_is_set(PINA, 2)) {

			while (!bit_is_set(PINA, 2));
			pos = 18;
		}

		// tasta 4
		if (!bit_is_set(PINA, 1)) {

			while (!bit_is_set(PINA, 1));
			pos = 9;
		}

		//tasta 1
		if (!bit_is_set(PINA, 0)) {

			while (!bit_is_set(PINA, 0));
			pos = 0;
		}

	}
}
